unit ger;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;


   TMyThread = class(TThread)
    private
      fStatusText : string;
      procedure ShowStatus;
    protected
      procedure Execute; override;
    public
      Constructor Create(CreateSuspended : boolean);
    end;


const
  VersionStr= {$I version.inc};

var
  Form1: TForm1;
  stop:boolean;
  MyThread : TMyThread;

implementation


constructor TMyThread.Create(CreateSuspended : boolean);
begin
  FreeOnTerminate := True;
  inherited Create(CreateSuspended);
end;


procedure TMyThread.ShowStatus;
begin
  Form1.Caption := fStatusText;
end;



procedure TMyThread.Execute;
var
  newStatus : string;
  i:Integer;
begin
  i:=0;
  fStatusText := 'TMyThread Starting...';
  Synchronize(@Showstatus);
  fStatusText := 'TMyThread Running...';
  while (not Terminated) and (not stop) do
    begin
//      inc(i);      // wenn man das entkommentiert stüzt ganz Linux ab
      NewStatus:=IntToStr(i);
      if NewStatus <> fStatusText then
        begin
          fStatusText := newStatus;
          Synchronize(@Showstatus);
        end;
    end;
end;


{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  MyThread := TMyThread.Create(True); // With the True parameter it doesn't start automatically
  if Assigned(MyThread.FatalException) then
    raise MyThread.FatalException;

  MyThread.Resume;
end;



procedure TForm1.Button2Click(Sender: TObject);
begin
  stop:=not stop;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ShowMessage(VersionStr);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  stop:=false;
end;





initialization
  {$I ger.lrs}

end.

